<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plait Webview Docs Source: server.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plait Webview Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="namespaces.list.html" class="dropdown-toggle" data-toggle="dropdown">Namespaces<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="socket.html">socket</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="Control.html">Control</a></li><li><a href="SessionControl.html">SessionControl</a></li><li><a href="Collection.html">Collection</a></li><li><a href="Overview.html">Overview</a></li><li><a href="Plugins.html">Plugins</a></li><li><a href="Editor.html">Editor</a></li><li><a href="FileMenu.html">FileMenu</a></li><li><a href="Form.html">Form</a></li><li><a href="Routing.html">Routing</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="global.html" class="dropdown-toggle" data-toggle="dropdown">Global<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="global.html#routing">routing</a></li><li><a href="global.html#control">control</a></li><li><a href="global.html#showSessions">showSessions</a></li><li><a href="global.html#TabButton">TabButton</a></li><li><a href="global.html#CueButton">CueButton</a></li><li><a href="global.html#CueBar">CueBar</a></li><li><a href="global.html#form">form</a></li><li><a href="global.html#editor">editor</a></li><li><a href="global.html#addGame">addGame</a></li><li><a href="global.html#createGame">createGame</a></li><li><a href="global.html#removeGame">removeGame</a></li><li><a href="global.html#inputPrompt">inputPrompt</a></li><li><a href="global.html#confirmation">confirmation</a></li><li><a href="global.html#identifyBrowser">identifyBrowser</a></li><li><a href="global.html#generateUUID">generateUUID</a></li><li><a href="global.html#namespace">namespace</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: server.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* @file create socket connection
* defines collection of functions to communicate with server application
* socket is a global variable so hat there is only one connection per session
* @copyright Lasse Marburg 2020
* @license GPLv3
*
*/


//var socket = io.connect(location.hostname + ":" + location.port)

/** determine namespace name for spcket connection
* @global
*/
namespace = window.location.pathname.slice(0, window.location.pathname.indexOf(page_name) + page_name.length)

/** connect to node app
* @namespace
*/
socket = io(namespace, { query: `browser=${identifyBrowser()}`}) // &amp;user=${localStorage.user}

console.log('socket connecting to namespace: ' + namespace)

socket.getNamespace = function(page_name) {
	return window.location.pathname.slice(0, window.location.pathname.indexOf(page_name) + page_name.length)
}

/**
* display alert
*/
socket.on('alert',function(data, uuid) {
	if(data &amp;&amp; uuid) {
		Swal(data)
		.then(result => {
			console.log("alert returns: " + result + " to " + uuid)
			let ret = {
				data: result,
				id: uuid
			}
			socket.emit('alert_response', ret)
		})
	}
})

/**
* show warning on disconnect
*/
socket.on('disconnect', function(data){
	Swal({
		icon:"warning",
		text:"Server disconnected. Consider downloading unsaved data"
	})
})

/**
*
* on connection established
* - close disconnect warning
* - add functions to socket variable
*/
socket.on('connect', function(data){
	console.log("server connected")

	if(Swal.getState().isOpen) {
		Swal.close()
	}
})

socket.command = function(key, property) {
	return new Promise(function(resolve, reject) {
		socket.get(key, property)
		.then(function(response) {
			if(response) {
				resolve(true)
			} else {
				reject(response)
			}
		})
	})
}

/**
* show alert when client not connected
*
* @returns {boolean} true if client connected, false if not. (same as socket.connected)
*/
socket.is_connected = function(cmd) {
	if(!socket.connected) {
		Swal({
			title: "Can't " + cmd,
			text: "no connection to server!",
			icon: "warning",
			buttons: false
		})
	}
	return socket.connected
}

/**
* example: call find method on database collection 'level' and query a name
* `get('find',{'level':{'name':'somename'}})`
*
* @param {string} key - address where or what to get stuff from
* @param {Object} property - specify your request
*
* @returns {Promise} response data. Will in case return empty data!
*/
socket.get = function (key, property) {
	return new Promise(function(resolve, reject) {
		if(!socket.is_connected('get data')){reject()}
		let uuid = generateUUID()
		let send = {data:property,id:uuid}
		socket.emit(key, send)
		socket.on(uuid, function(data) {
			if(data) {
				resolve(data)
			} else {
				console.warn("Empty return value for '" + key + " "+ property + "'")
				resolve(data)
			}
			socket.removeAllListeners(key)
		})
	})
}

/**
* call update function on database content
*
* @param {string} collection - database collection (view or table) to change
* @param {Object} query - query to address database document
* @param {Object} data - dataset to replace document(s) with
*/
socket.update = function(collection, query, data) {
	return new Promise(function(resolve, reject) {
		let send = {id:generateUUID()}
		let d = new Date()
		//data["modified"] = new Date(Date.now())// d.toUTCString()
		send['collection'] = collection
		send['query'] = query
		send['data'] = data
		console.log(send)
		socket.emit('replace', send)
		socket.on(send.id, function(result) {
			resolve(result)
		})
	})
	
}

/**
* call insert function on database content
*
* @param {string} collection - database collection (view or table) to change
* @param {Object} data - dataset to replace document(s) with
*/
socket.insert = function(collection, data) {
	return new Promise(function(resolve, reject) {
		let send = {id:generateUUID()}
		send['collection'] = collection
		send['data'] = data
		console.log(send)
		socket.emit('insert', send)
		socket.on(send.id, function(result) {
			console.log("inserted:")
			console.log(result)
			return resolve(result)
		})
	})
	
}

/**
* call slice/delete function on database content
*
* @param {string} collection - database collection (view or table) to change
* @param {Object} query - query to address document to be removed
*/
socket.remove = function(collection, query) {
	return new Promise((resolve, reject) => {
		let send = {id:generateUUID()}
		send['collection'] = collection
		send['query'] = query
		console.log(send)
		socket.emit('remove', send)
		socket.on(send.id, function(result) {
			console.log("removed:")
			console.log(result)
			return resolve(result)
		})
	})
	
}

/**
* write documents (back) to database
* to replace a database entry it is dependend on _id property
*
* @param {Object} data - docuemnt to update or insert
* @param {string} data.name - so far data
* @param {string} collection - name of collection to save data to
* @param {string} [docname] - save under a different name
*
* @returns {Promise} true if successful
*/
socket.save = function(save_data, collection, doc_name) {
  return new Promise(function(resolve, reject) {
		if(!socket.is_connected('save file')){reject()}
		save_data["modified"] = new Date(Date.now())// d.toUTCString()
		let data = Object.assign({}, save_data)
    console.log("save:")
    console.log(data)
    if(doc_name) {
      data['name'] = doc_name
      socket.insert(collection, data)
			.then(function(result) {
				resolve( socket.saveResult(data, result) )
			})
    } else if (!data._id) {
      socket.insert(collection, data)
			.then(function(result) {
				resolve( socket.saveResult(data, result) )
			})
    } else {
      socket.update(collection, {'_id':data._id}, data)
			.then(function(result) {
				resolve( socket.saveResult(data, result) )
			})
    }
  });
}

/**
* check for errors in save result
* calls success or fail function accordingly
*
* @param {Object} data - data set that was tried to be stored
* @param {Object} result - result that was returned by server on save process
*
* @returns {*} false if there was an error in the result, else the result object itself
*/
socket.saveResult = function(data, result) {
	if(result.hasOwnProperty('writeError')) {
		socket.saveFailed(data, result.writeErrors)
		return false
	} else if (result.hasOwnProperty('writeConcernError')) {
		socket.saveFailed(data, result.writeConcernError)
		return false
	} else {
		socket.saveSuccessfull(data)
		return result
	}
}

/**
* show save was successful alert
*
* @param {Object} data - alert shows data.name if any
*/
socket.saveSuccessfull = function(data) {
	let title = ''
	if(data.hasOwnProperty('name')) {
		title = data.name
	} else {
		title = 'unnamed file'
	}

	Swal({
		text: title + " saved",
		icon: "success",
		buttons: false,
		timer: 1000
	})
}

/**
* show save failed alert with error message
*
* @param {Object} data - alert shows data.name if any
* @param {string} error - error message
*/
socket.saveFailed = function(data, error) {
	let name = ''
	if(data.hasOwnProperty('name')) {
		name = data.name
	} else {
		name = 'unnamed file'
	}
	
	Swal({
		title: "Failed to save " + name,
		text: error,
		icon: "warning",
		buttons: false
	})
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/'>Plaiframe Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
